﻿/// <reference path="/resources/JQuery/jquery-1.7-vsdoc.js" />

function proget_viewdeployment(o) {
    var pauseAutoScroll = false;
    var animating = false;
    var nextSequenceNumber = o.nextSequenceNumber;
    var deployStatus = o.status;

    $('#' + o.logContainerId).scroll(function () {
        if (!animating) {
            pauseAutoScroll = true;
        }
        if (this.scrollTop + $(this).innerHeight() >= this.scrollHeight) {
            pauseAutoScroll = false;
        }
    });

    function autoScroll() {
        if (!pauseAutoScroll) {
            animating = true;
            $('#' + o.logContainerId)[0].scrollTop = $('#' + o.logContainerId)[0].scrollHeight;
            animating = false;
        }
    }

    var interval = setInterval(
        function () {
            $.ajax(o.ajaxUpdateUrl + '?deploymentId=' + o.deploymentId + '&sequenceNumber=' + nextSequenceNumber,
            {
                type: 'post',
                cache: 'false',
                dataType: 'json'
            }).done(function (data) {
                for (var i = 0; i < data.logEntries.length; i++) {
                    $('#' + o.logContainerId).append($('<span></span>').text(data.logEntries[i]));
                }

                nextSequenceNumber = data.deployment.nextLogSequence;

                var statusText;
                var statusImg;

                if (data.deployment.status != deployStatus) {
                    deployStatus = data.deployment.status;
                    if (deployStatus == 'I') {
                        statusText = 'In Progress';
                        statusImg = 'loading.gif';
                    } else if(deployStatus == 'S') {
                        statusText = 'Succeeded';
                        statusImg = 'success.svg';
                    } else if (deployStatus == 'F') {
                        statusText = 'Failed';
                        statusImg = 'fail.svg';
                    } else {
                        statusText = 'Pending';
                        statusImg = 'pending.svg';
                    }

                    $('#' + o.statusContainerId + ' img').attr('src', '/resources/images/icons/status-' + statusImg);
                    $('#' + o.statusContainerId + ' span').text(statusText);

                    $('#' + o.startTimeId).text(data.deployment.startTime);
                    $('#' + o.endTimeId).text(data.deployment.endTime);
                }

                if (data.deployment.status == 'S' || data.deployment.status == 'F') {
                    clearInterval(interval);
                }
            });

            autoScroll();
        },
        500
    );
}